
local tabID = -1;
local MAX_VISIBLE_BTN = 8;
local FRIEND_ENTRY_HEIGHT = 36;
local FRIEND_ENTRY_MARGIN = 2;
local FriendsListTable = {};
local hook_FriendsFrame_Update = FriendsFrame_Update;



function FriendsListPlus_OnLoad()
    

    SLASH_FLP1 = "/gankmode"
    SLASH_FLP2 = "/friendslistplus"
    SlashCmdList["FLP"] = function(msg)
        FriendsListPlus_GetFriendInfoSlash();
    end

    SLASH_FLPDEBUG1 = "/flpd"
    SlashCmdList["FLPDEBUG"] = function(msg)
        print("Friends List Plus Debug");
    end

    FriendsListPlus_PopulateFriendsTable();
    FriendsListPlus_LoadListFrames();
    

    local s = FriendsListPlusFrame:RegisterEvent("FRIENDLIST_UPDATE");
    FriendsListPlusFrame:SetScript('OnEvent', function(self)
        FriendsListPlus_PopulateFriendsTable();
        FriendsListPlus_UpdateList();
    end);

end

function FriendsListPlus_OnShow()
    -- NO-OP
end

function FriendsListPlus_GetFriendInfoSlash()
    totalBNet, numBNetOnline = BNGetNumFriends()
    print("Friends:")
    for i = 1, totalBNet do
        presenceID, presenceName, battleTag, isBattleTagPresence, toonName, toonID, client, isOnline, lastOnline, isAFK, isDND, messageText, noteText, isRIDFriend, broadcastTime, canSoR = BNGetFriendInfo(i);
        if isOnline and toonName ~= nil and toonID ~= nil then
            hasFocus, characterName, client, realmName, realmID, faction, race, class, guild, zoneName, level, gameText, broadcastText, broadcastTime, canSoR, toonID, bnetIDAccount, isGameAFK, isGameBusy  = BNGetGameAccountInfo(toonID)
            tmp = "" .. presenceName .. " (" .. characterName .. ")" .. " is in " .. zoneName .. " as " .. "(" .. race .. " " .. class .. " lvl: " .. level .. ")";
            -- Server
            tmp = tmp .. " (Server: " .. realmName .. ")";
            if isGameAFK then
                tmp = tmp .. " (AFK)"
            end

            print(tmp)
        end
    end
    print("");
end


function FriendsListPlus_LoadListFrames()
    
    -- Load Tab Button
    tabID = 1
    while _G["FriendsTabHeaderTab"..tabID] do
        tabID = tabID + 1
    end


    local tab = CreateFrame("Button", "FriendsTabHeaderTab"..tabID, FriendsTabHeader, "TabButtonTemplate")
    tab:SetPoint("LEFT", _G["FriendsTabHeaderTab"..(tabID-1)]:IsShown() and _G["FriendsTabHeaderTab"..(tabID-1)] or _G["FriendsTabHeaderTab"..(tabID-2)], "RIGHT", 0, 0)
    tab:SetText("Friends +")
    tab:SetID(tabID)

    tab:SetScript("OnClick", function(self)
    	PanelTemplates_Tab_OnClick(self, FriendsTabHeader)
        FriendsFrame_Update()
    end)

    PanelTemplates_TabResize(tab, 0)
    tab:SetWidth(tab:GetTextWidth() + 31)
    PanelTemplates_SetNumTabs(FriendsTabHeader, tabID)
    PanelTemplates_SetTab(FriendsTabHeader, 1) -- Select which tab that gets pre-selected

    -- Load List Frame
    FriendsListPlusFrame:SetPoint("TOPRIGHT", -12, -76)
    FriendsListPlusFrame:SetPoint("BOTTOMRIGHT", 0, 0)
    FriendsListPlusFrame:SetPoint("BOTTOMLEFT", 0, 17)

    -- Scrollframe 
    local scrollframe = CreateFrame("ScrollFrame", "FriendsListPlusScrollFrame", FriendsListPlusFrame, "FauxScrollFrameTemplate") 
    scrollframe:SetPoint("TOPLEFT", 10, -10) 
    scrollframe:SetPoint("BOTTOMRIGHT", -20, 10) 
    FriendsListPlusFrame.scrollframe = scrollframe 

    scrollframe:SetScript("OnVerticalScroll", function(msg, offset)
        FauxScrollFrame_OnVerticalScroll(scrollframe, offset, FRIEND_ENTRY_HEIGHT + FRIEND_ENTRY_MARGIN, FriendsListPlus_UpdateList);
    end)

    -- Scrollbar Textures
    local texture = FriendsListPlusFrame:CreateTexture("ScrollTextTop", "BACKGROUND");
    texture:SetSize(29, 102);
    texture:SetPoint("TOPLEFT", FriendsListPlusScrollFrame, "TOPRIGHT", -2, 4);
    texture:SetTexCoord(0, 0.445, 0, 0.4);
    texture:SetTexture("Interface\\PaperDollInfoFrame\\UI-Character-ScrollBar");
    FriendsListPlusFrame.background = texture;

    local texture = FriendsListPlusFrame:CreateTexture("ScrollTextBottom", "BACKGROUND");
    texture:SetSize(29, 106);
    texture:SetPoint("BOTTOMLEFT", FriendsListPlusScrollFrame, "BOTTOMRIGHT", -2, -2);
    texture:SetTexCoord(0.515625, 0.960625, 0, 0.4140625);
    texture:SetTexture("Interface\\PaperDollInfoFrame\\UI-Character-ScrollBar");
    FriendsListPlusFrame.background = texture;

    local texture = FriendsListPlusFrame:CreateTexture(nil, "BACKGROUND");
    texture:SetSize(29, 1);
    texture:SetPoint("TOP", ScrollTextTop, "BOTTOM", 0, 0);
    texture:SetPoint("BOTTOM", ScrollTextBottom, "TOP", 0, 0);
    texture:SetTexCoord(0, 0.445, 0.75, 1);
    texture:SetTexture("Interface\\PaperDollInfoFrame\\UI-Character-ScrollBar");
    FriendsListPlusFrame.background = texture;

    -- Content frame
    local content = CreateFrame("Frame", "FriendsListPlusContentFrame", FriendsListPlusFrame)
    content:SetSize(196, 96)
    content:SetPoint("TOPLEFT", 0, 0)
    content:SetPoint("BOTTOMRIGHT", 0, 0)

    -- Populate all buttons
    FriendsListPlus_PopulateFriendsEntryFrames();    
    
    FauxScrollFrame_OnVerticalScroll(scrollframe, 0, FRIEND_ENTRY_HEIGHT + FRIEND_ENTRY_MARGIN, FriendsListPlus_UpdateList)
    FriendsListPlus_UpdateList();


    FriendsListPlusFrame:Hide();
    scrollframe:Hide();
end



function FriendsFrame_Update()
	if FriendsTabHeader.selectedTab ~= tabID then
		FriendsListPlus_HideTab()
		return hook_FriendsFrame_Update()
    end
    
    FriendsFrameTitleText:SetText("Friends List +")
    FriendsFrame_ShowSubFrame("FriendsListPlusFrame")
    FriendsTabHeader:Show() -- not sure why it sometimes hides itself
	
	if not FriendsListPlusFrame:IsShown() then
        FriendsListPlus_UpdateList();
        FriendsListPlus_TabHeaderClick();
	end
end

function FriendsListPlus_TabHeaderClick()
    FriendsListPlusFrame:SetHeight(FriendsFrameInset:GetHeight())
    FriendsListPlusFrame:SetWidth(FriendsFrameInset:GetWidth()-20)
    FriendsListPlusFrame:Show();
end

function FriendsListPlus_HideTab()
    FriendsListPlusFrame:Hide();
end

function FriendsListPlus_UpdateList()
    local line;
    local lineplusoffset;
    FauxScrollFrame_Update(FriendsListPlusScrollFrame, #FriendsListTable, MAX_VISIBLE_BTN, FRIEND_ENTRY_HEIGHT + FRIEND_ENTRY_MARGIN);
    for line=1,MAX_VISIBLE_BTN do
        lineplusoffset = line + FauxScrollFrame_GetOffset(FriendsListPlusScrollFrame)
        if lineplusoffset <= #FriendsListTable then
            local entryText = " ";
            -- Online icon
            if FriendsListTable[lineplusoffset].afk then
                -- afk
                entryText = entryText .. "|TInterface\\FriendsFrame\\StatusIcon-Away:0|t"
            elseif FriendsListTable[lineplusoffset].busy then
                -- busy
                entryText = entryText .. "|TInterface\\FriendsFrame\\StatusIcon-DnD:0|t"
            else
                -- online
                entryText = entryText .. "|TInterface\\FriendsFrame\\StatusIcon-Online:0|t"
            end
            -- name
            entryText = entryText .. " " .. FriendsListTable[lineplusoffset].bnetName .. " (" .. FriendsListTable[lineplusoffset].characterName .. ")";
            -- Level
            entryText = entryText .. " |c" .. FriendsListPlus_GetColorCode(FriendsListTable[lineplusoffset].faction) .. FriendsListTable[lineplusoffset].level .. "|r" 
            -- race
            entryText = entryText .. " |c" .. FriendsListPlus_GetColorCode(FriendsListTable[lineplusoffset].faction) .. FriendsListTable[lineplusoffset].race .. "|r";
            -- class
            entryText = entryText .. " |c" .. FriendsListPlus_GetColorCode(FriendsListTable[lineplusoffset].faction) .. FriendsListTable[lineplusoffset].class .. "|r";
            -- newline
            entryText = entryText .. "\n";
            -- zone + realm
            if FriendsListTable[lineplusoffset].zone == "" or FriendsListTable[lineplusoffset].realm == "" then
                entryText = entryText .. "      " .. FriendsListTable[lineplusoffset].gameText;
            else
                entryText = entryText .. "      " .. FriendsListTable[lineplusoffset].zone .. " - " .. FriendsListTable[lineplusoffset].realm .. "";
            end
            

            -- text width = 35 letters?
            getglobal("FriendsListPlusEntry"..line):SetText(entryText);
            getglobal("FriendsListPlusEntry"..line):Show();
        else
            getglobal("FriendsListPlusEntry"..line):Hide();
        end
    end
end

function FriendsListPlus_PopulateFriendsEntryFrames()
    for i=1,MAX_VISIBLE_BTN do
        local btn = CreateFrame("Button", "FriendsListPlusEntry" .. i, FriendsListPlusContentFrame) 
        btn:SetHeight(FRIEND_ENTRY_HEIGHT);
        if i == 1 then
            btn:SetPoint("TOPLEFT", "FriendsListPlusScrollFrame", "TOPLEFT", 0, 0)
            btn:SetPoint("TOPRIGHT", "FriendsListPlusScrollFrame", "TOPRIGHT", -2, 0)
        else
            btn:SetPoint("TOPLEFT", "FriendsListPlusEntry"..(i-1), "BOTTOMLEFT", 0, - FRIEND_ENTRY_MARGIN)
            btn:SetPoint("TOPRIGHT", "FriendsListPlusEntry"..(i-1), "BOTTOMRIGHT", 0, - FRIEND_ENTRY_MARGIN)
        end
        btn:SetID(1)
        btn:SetNormalFontObject("GameFontHighlightLeft")

        local texture = btn:CreateTexture() 
        texture:SetAllPoints() 
        texture:SetTexture("Interface\\DialogFrame\\UI-DialogBox-Background")
        btn.texture = texture 
        btn:Hide();
    end
end


function FriendsListPlus_PopulateFriendsTable()
    FriendsListTable = {};
    totalBNet, numBNetOnline = BNGetNumFriends();
    for i = 1, totalBNet do
        _, presenceName, _, _, toonName, toonID, _, isOnline, _, isAFK, isDND, _, _, _, _, _ = BNGetFriendInfo(i);
        if isOnline and toonName ~= nil and toonID ~= nil then
            _, characterName, _, realmName, _, faction, race, class, _, zoneName, level, gameText, _, _, _, _, _, isGameAFK, isGameBusy  = BNGetGameAccountInfo(toonID)

            local tmpTable = {}
            tmpTable.bnetName = presenceName;
            tmpTable.isOnline = isOnline;
            tmpTable.afk = isGameAFK;
            tmpTable.busy = isGameBusy;
            tmpTable.characterName = characterName;
            tmpTable.realm = realmName;
            tmpTable.faction = faction;
            tmpTable.race = race;
            tmpTable.class = class;
            tmpTable.zone = zoneName;
            tmpTable.level = level;
            tmpTable.gameText = gameText;

            FriendsListTable[i] = tmpTable;
        end
    end
end

function FriendsListPlus_GetColorCode(msg)

    if msg == "Alliance" then
        return "ff0351b3";
    elseif msg == "Horde" then
        return "ffcc0301";
    elseif msg == "Death Knight" then
        return "ffc41f3b";
    elseif msg == "Demon Hunter" then
        return "ffa330c9";
    elseif msg == "Druid" then
        return "ffff7d0a";
    elseif msg == "Hunter" then
        return "ffabd473";
    elseif msg == "Mage" then
        return "ff40c7eb";
    elseif msg == "Monk" then
        return "ff00ff96";
    elseif msg == "Paladin" then
        return "fff58cba";
    elseif msg == "Priest" then
        return "ffffffff";
    elseif msg == "Rogue" then
        return "fffff569";
    elseif msg == "Shaman" then
        return "ff0070de";
    elseif msg == "Warlock" then
        return "ff8787ed";
    elseif msg == "Warrior" then
        return "ffc79c6e";
    end

    return "ffffffff";
end

